module.exports = {
	root: true,
	extends: [
		"airbnb",
		"airbnb/hooks",
		"airbnb-typescript",
		"eslint-config-airbnb-typescript",
		"eslint:recommended",
		"plugin:react/recommended",
		"plugin:flowtype/recommended",
		"plugin:@typescript-eslint/eslint-recommended",
		"plugin:@typescript-eslint/recommended",
	],
	parser: "@typescript-eslint/parser",
	parserOptions: {
		ecmaFeatures: {
			jsx: true,
		},
		sourceType: "module",
		project: "tsconfig.json",
	},
	rules: {
		"import/prefer-default-export": "off",
		"react/jsx-props-no-spreading": "off",
		"flowtype/no-types-missing-file-annotation": "off",
		"@typescript-eslint/explicit-function-return-type": [
			"warn",
			{
				allowExpressions: true,
				allowTypedFunctionExpressions: true,
			},
		],
		"@typescript-eslint/no-use-before-define": [
			"warn",
			{
				functions: false,
				classes: true,
				variables: true,
				typedefs: true,
			},
		],
		camelcase: "off",
		"@typescript-eslint/naming-convention": [
			"warn",
			{
				selector: "default",
				format: ["PascalCase", "camelCase", "snake_case", "UPPER_CASE"],
				leadingUnderscore: "allowDouble",
			},
			{
				selector: "variable",
				format: ["PascalCase", "camelCase", "snake_case", "UPPER_CASE"],
				leadingUnderscore: "allowDouble",
			},
			{
				selector: "memberLike",
				format: ["camelCase", "snake_case", "PascalCase"],
				leadingUnderscore: "allowDouble",
			},
			{
				selector: "parameter",
				format: ["camelCase", "snake_case", "PascalCase"],
				leadingUnderscore: "allowDouble",
			},
			{
				selector: "function",
				format: ["PascalCase", "camelCase"],
			},
			{
				selector: "classMethod",
				format: ["PascalCase", "camelCase"],
			},
			{
				selector: "class",
				format: ["PascalCase"],
			},
			{
				selector: "interface",
				format: ["PascalCase"],
			},
			{
				selector: "enum",
				format: ["PascalCase"],
			},
			{
				selector: "typeParameter",
				format: ["PascalCase"],
			},
		],
		"react/function-component-definition": [
			0,
			{
				namedComponents: "function-declaration",
				unnamedComponents: "function-expression",
			},
		],
		"object-curly-newline": 0,
		"no-param-reassign": 0,
		"prefer-const": 0,
		"no-console": 0,
		"jsx-indent": 0,
		"no-tabs": 0,
		"react/require-default-props": [0],
		"import/no-default-export": "off",
		"react/jsx-one-expression-per-line": "off",
		"no-prototype-builtins": "off",
		"react/destructuring-assignment": "off",
		"comma-dangle": 0,
		"react-hooks/exhaustive-deps": 0,
		"no-unused-vars": 0,
		"global-require ": 0,
		"no-extra-boolean-cast": 0,
		"no-plusplus": 0,
		"prefer-regex-literals": 0,
		"@typescript-eslint/no-empty-interface": 0,
		"implicit-arrow-linebreak": 0,
		"function-paren-newline": 0,
		"guard-for-in": 0,
		"arrow-parens": ["warn", "always", { requireForBlockBody: true }],
		"@typescript-eslint/no-unused-vars": 0,
		"@typescript-eslint/ban-ts-comment": 0,
		quotes: [0, "double", { avoidEscape: true }],
		"@typescript-eslint/quotes": [0, "double", { avoidEscape: true }],
		indent: ["off", "tab"],
		"@typescript-eslint/indent": ["off", "tab"],
		"linebreak-style": ["error", "unix"],
		semi: ["warn", "always"],
		"import/no-relative-packages": 0,
	},
	plugins: ["react", "react-native", "@typescript-eslint", "only-warn"],
};
